function [model,total_time, iter, obj] = offline_relational(fname, param)
% fname = 'data/dblp-train.mat';
%  param.tol = 0.1;
load(fname);
newparam  = param;

if ~isfield(param, 'weight_temporal')
    newparam.weight_temporal = 1;
end

if ~isfield(param, 'tol')
    newparam.tol = 0.01;
end

if ~isfield(param, 'maxIter')
    newparam.maxIter = 20;
end

num_relation = length(R{1}.relation);
num_months = length(R);

if ~isfield(param, 'numC')
    newparam.numC = 4*ones(num_relation+1, 1);
end

if ~isfield(param, 'weights')
    newparam.weights = ones(num_relation, 1);
end

if ~isfield(param, 'normalize')
    newparam.normalize = false;
end


if isfield(param, 'weight_temporal')
    newparam.weight_temporal = param.weight_temporal*ones(num_relation, 1);
else
    newparam.weight_temporal = ones(num_relation,1);
end

param = newparam;

tol = param.tol;
maxIter = param.maxIter;
numC = param.numC;


%%% initialize the cluster indicator for each timestamp
%num_months = 2;
model= cell(num_months,1);

for month = 1:num_months
    clear temp

    model{month}.activeIndex = activeIndex{month};
    model{month}.num_entity = num_entity{month};
    model{month}.num_original = num_original;
    num_paper = size(R{month}.relation{1},1);
    model{month}.cluster = initialize_cluster(model{month}.num_entity, num_paper);
       
    if newparam.normalize == true
        for I = 1:length(newparam.weights)
            param.weights(I) = newparam.weights(I) / (num_paper * num_entity{month}(I));
        end
    end
    param.maxIter = 1;
    param.kmeans  = false;
    month
    model{month}  = online_one(R{month}, model{month}, param);
end


%param.temporal_weight=1;
% define convergence flag
convergence_flag = false;
obj_pre =0;
iter = 0;

%%
%tol = 10^-6;
%%


%%%%%%%%%%%% Iterative Update %%%%%%%%%%%%%%%%%%%%%%%%%

initial_time = cputime;
obj_history = [];


while true
    iter = iter+1;
    % iterative solve the problem
    obj = 0;
    
    % iterativelly update the cluster indicator for each mode at each timestamp
    for month=1:num_months
        month
        clear temporal;

        switch month
            case 1
                temporal.after = mapping(model{2}.cluster, num_original, numC, activeIndex{2}, activeIndex{1});
            case num_months
                temporal.prior = mapping(model{num_months-1}.cluster, num_original, numC, ...
                    activeIndex{num_months-1}, activeIndex{num_months});
            otherwise
                temporal.prior = mapping(model{month-1}.cluster, num_original, numC, ...
                    activeIndex{month-1}, activeIndex{month});
                temporal.after = mapping(model{month+1}.cluster, num_original, numC, ...
                    activeIndex{month+1}, activeIndex{month});
        end
        
        if newparam.normalize == true
            num_paper = size(R{month}.relation{1}, 1);
            for I = 1:length(newparam.weights)
                param.weights(I) = newparam.weights(I) / (num_paper * num_entity{month}(I));
            end

            for I = 1:length(param.weight_temporal)
                param.weight_temporal(I) = newparam.weight_temporal(I)/newparam.numC(I);
            end

        end
        [model{month}]  = offline_one(R{month}, model{month}, temporal,param, convergence_flag);
        %diff_total = diff_total+ model{month}.diff;
        obj = obj + model{month}.obj;

        clear temporal;
    end
    obj
    obj_history = [obj_history, obj];
    
    if convergence_flag == true
      break;
    end
    
    if (obj-obj_pre)/obj < tol || iter>maxIter
        convergence_flag = true;
    end
    obj_pre = obj;
    
end

total_time = cputime-initial_time;
model{1}.obj_history = obj_history;

